'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.retryLastAction = exports.resetErrorState = undefined;

var _reduxTypes = require('./reduxTypes');

var _config = require('./config');

const resetErrorState = exports.resetErrorState = () => ({
  type: _reduxTypes.RESET_ERROR_STATE
});

const retryLastAction = exports.retryLastAction = (reducerName = null) => (dispatch, getState) => {
  // necessary since in react native after dispatch you automatically have a
  // Proxy Event as first argument
  if (typeof reducerName !== 'string') {
    // eslint-disable-next-line no-param-reassign
    reducerName = _config.defaultReducerName;
  }
  const reducerState = getState().get(reducerName);
  const action = reducerState.get('action');
  const args = reducerState.get('args');
  dispatch(resetErrorState());
  dispatch(action(...args));
};