'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reducerCreator = exports.initialState = undefined;

var _immutable = require('immutable');

var _reduxTypes = require('./reduxTypes');

var _utils = require('./utils');

const initialState = exports.initialState = (0, _immutable.Map)({
  meta: {}
});


const reducer = (state = initialState, lastAction) => {
  const {
    type,
    error,
    action,
    args,
    meta
  } = lastAction;

  if (type === _reduxTypes.RESET_ERROR_STATE) {
    return initialState;
  } else if (error) {
    return state.mergeDeep({
      error,
      action,
      args,
      meta
    });
  }

  return state;
};

exports.default = reducer;
const reducerCreator = exports.reducerCreator = (blacklist = []) => (state, action) => {
  if ((0, _utils.existsIn)(action.type, blacklist)) {
    return initialState;
  }

  return reducer(state, action);
};